#include <libusb.h>
#include "libfreenect.h"


@interface KinectPatch : QCPatch
{
	QCBooleanPort *outputConnected;
	QCImagePort *outputColorImage;
	QCImagePort *outputDepthImage;

	libusb_context *uContext;
	libusb_device_handle *uDevice;
	QCOpenGLContext *glContext;
}

+(BOOL)allowsSubpatchesWithIdentifier:(id)identifier;
+(QCPatchExecutionMode)executionModeWithIdentifier:(id)identifier;
-(id)initWithIdentifier:(id)identifier;
-(void)enable:(QCOpenGLContext*)context;
-(void)disable:(QCOpenGLContext*)context;
-(BOOL)execute:(QCOpenGLContext*)context time:(double)time arguments:(NSDictionary*)arguments;

- (void)updateDepthImageWithBuffer:(uint16_t *)buf;
- (void)updateColorImageWithBuffer:(uint8_t *)buf;

@end
